
package biteme;

/**
 * Enumeration for level editor. Each value represents a type of Tile that can be placed on the Maze.
 * @author N.F.W. Thissen
 */
public enum EditorTileType {
    /** Represents an EmptyTile. */
    NONE (0),
    /** Represents an EmptyTile with a coin. */
    COIN (1),
    /** Represents a WallTile. */
    WALL (2),
    /** Represents an EmptyTile with a box. */
    BOX (3),
    /** Represents a OneWayTile directed up. */
    ONE_WAY_UP (4),
    /** Represents a OneWayTile directed down. */
    ONE_WAY_DOWN (5),
    /** Represents a OneWayTile directed left. */
    ONE_WAY_LEFT (6),
    /** Represents a OneWayTile directed right. */
    ONE_WAY_RIGHT (7),
    /** Represents the PacmanEntity. */
    PACMAN (8),
    /** Represents a SmartGhost. */
    SMART_GHOST (9),
    /** Represents a StupidGhost. */
    STUPID_GHOST (10);

    /** The value of the enumeration. */
    private int value;

    /**
     * Constructor.
     * @param val The value of the enumeration.
     */
    EditorTileType(int val) {
        value = val;
    }
}
