package biteme;



import java.util.Calendar;

/**
 * Structure for storing HighScores.
 * @authors NFW Thissen
 *          JH van der Aa
 */
public class HighScore {
    
    private int score;
    private String name;
    private Calendar date;

      /**
     * Constructor, that sets standard values for a score
     *
     */
public HighScore(){
    name = "Name";
    score = Integer.MAX_VALUE;
    date = Calendar.getInstance();

}
     /**
     * Sets or edits a highscore
      * @param aScore the score of this highscore
      * @param aName the playername that set the highscore
      * @param aDate the date this highscore was set
     */
 public void setScore(int aScore,String aName, Calendar aDate){
     score = aScore;
     name = aName;
      date = aDate;
 }

   /**
     * @return the score
    */
 public int getScore(){
     return score;
 }

   /**
     * 
     *
    * @return the username for this score
    */
  public String getName(){
     return name;
 }

    /**
     * 
     *
     * @return the date the score was set on
     */
   public Calendar getDate(){
     return date;
 }
   
   /**
    *
    * @return the date in string format ddmmyyyy
    */
   public String getDateString(){
       String day;
       String month;

       if (date.get(Calendar.DAY_OF_MONTH) < 10){
           day = "0" +date.get(Calendar.DAY_OF_MONTH);
       } else { day = "" +date.get(Calendar.DAY_OF_MONTH);
       }
              if (date.get(Calendar.MONTH) < 9){
                  //months start at 0 for some reason..
           int monthint = (date.get(Calendar.MONTH));//+1;
           month = "0" +monthint;
       } else {
           int monthint = (date.get(Calendar.MONTH));//+1;
           month = "" +monthint;
       }
       return day +month +date.get(Calendar.YEAR);
   }

   /**
    *
    * @return the date in dd-mm-yyyy format
    */
   public String getDateFormat(){
       String day;
       String month;

       if (date.get(Calendar.DAY_OF_MONTH) < 10){
           day = "0" +date.get(Calendar.DAY_OF_MONTH);
       } else { day = "" +date.get(Calendar.DAY_OF_MONTH);
       }
              if (date.get(Calendar.MONTH) < 9){
                  //months start at 0 for some reason..
           int monthint = (date.get(Calendar.MONTH))+1;
           month = "" +monthint;
       } else {
           int monthint = (date.get(Calendar.MONTH))+1;
           month = "" +monthint;
       }
       return day +"-" +month +"-" +date.get(Calendar.YEAR);
   }
}
