/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * LevelSelect.java
 *
 * Created on 9-dec-2009, 14:30:35
 */
package biteme;

import java.awt.Dimension;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.io.*;
import javax.swing.*;


/**
 * Level select class (GUI)
 * @author s050606
 */
public class LevelSelect extends javax.swing.JFrame implements ILoadMazeThreadListener {

    private LoadMazeThread t;
    JFrame parent;
    private String selectedLevel = null;
    private String nextLevel = null;

    /**
     * Creates new form LevelSelect
     */
    public LevelSelect(JFrame pParent) {
        parent = pParent;

        initComponents();

        this.previewMaze.setLayout(new GridBagLayout());
        this.previewMaze.validate();        

        setIconImage(Toolkit.getDefaultToolkit().getImage(MainMenu.class.getResource("biteme_icon.png")));
        setTitle("BiteMe - Level select");

        Dimension minSize = new Dimension(980, 900);
        this.setMinimumSize(minSize);
        this.setPreferredSize(minSize);
        this.validate();
        getLevels();
        previewMaze.setTileSize(10);
    
        // By defalt, draw a preview of the first level and add the topscores.
        selectedLevel = Path.getMazesPath() + LevelList.getLevelAtIndex(0) + ".ply";
        setScores();

        t = new LoadMazeThread(previewMaze, selectedLevel);
        t.addLoadMazeListener(this);
        t.start();
        LevelList.setSelectedIndex(0);
    }

    /**
     * This method finds the top scores and puts them in the text area below the preview.
     */
    public void setScores() {
        HighScore[] scoreAllTime = new HighScore[10];
            HighScore[] scoreWeek = new HighScore[10];
            HighScore[] scoreDay = new HighScore[10];
            for(int i = 0; i<10; i++){
                scoreAllTime[i] = MazeIO.loadAllTimeScores(selectedLevel).getScore(i+1);
            }
            for(int i = 0; i<10; i++){
                scoreWeek[i] = MazeIO.loadWeekScores(selectedLevel).getScore(i+1);
            }
            for(int i = 0; i<10; i++){
                scoreDay[i] = MazeIO.loadDayScores(selectedLevel).getScore(i+1);
            }

            String s = "Top scores \t Name: \t Score: \t Date:\nAll times: ";
            int j = 0;
            while (j<10 && scoreAllTime[j].getScore() != Integer.MAX_VALUE) {
                s = s + "\t " + (j+1) + ":  " + scoreAllTime[j].getName() + "\t" +
                        scoreAllTime[j].getScore() +"\t" +scoreAllTime[j].getDateFormat() + "\n";
                j++;
            }
            s = s + "\nThis week: ";
            j=0;
            while (j<10 && scoreWeek[j].getScore() != Integer.MAX_VALUE) {
                s = s + "\t " + (j+1) + ":  " + scoreWeek[j].getName() + "\t" +
                        scoreWeek[j].getScore() +"\t" +scoreWeek[j].getDateFormat() + "\n";
                j++;
            }
            s = s + "\nThis day: ";
            j=0;
            while (j<10 && scoreDay[j].getScore() != Integer.MAX_VALUE) {
                s = s + "\t " + (j+1) + ":  " + scoreDay[j].getName() + "\t" +
                        scoreDay[j].getScore() +"\t" +scoreDay[j].getDateFormat() + "\n";
                j++;
            }

        jTextArea1.setText(s);

//        jTextArea1.setText("Top scores \t Name: \t Score: \t Date:\n" +
//                "All times: " + "\t 1:  " + scoreAllTime[0].getName() + "\t" +scoreAllTime[0].getScore() +"\t" +scoreAllTime[0].getDateFormat() +"\n"
//                + "\t 2:  " + scoreAllTime[1].getName() + "\t" +scoreAllTime[1].getScore() +"\t" +scoreAllTime[1].getDateFormat() + "\n"
//                + "\t 3:  " + scoreAllTime[2].getName() + "\t" +scoreAllTime[2].getScore() +"\t" +scoreAllTime[2].getDateFormat() + "\n"
//                + "\t 4:  " + scoreAllTime[3].getName() + "\t" +scoreAllTime[3].getScore() +"\t" +scoreAllTime[3].getDateFormat() + "\n"
//                + "\t 5:  " + scoreAllTime[4].getName() + "\t" +scoreAllTime[4].getScore() +"\t" +scoreAllTime[4].getDateFormat() + "\n"
//                + "\t 6:  " + scoreAllTime[5].getName() + "\t" +scoreAllTime[5].getScore() +"\t" +scoreAllTime[5].getDateFormat() + "\n"
//                + "\t 7:  " + scoreAllTime[6].getName() + "\t" +scoreAllTime[6].getScore() +"\t" +scoreAllTime[6].getDateFormat() + "\n"
//                + "\t 8:  " + scoreAllTime[7].getName() + "\t" +scoreAllTime[7].getScore() +"\t" +scoreAllTime[7].getDateFormat() + "\n"
//                + "\t 9:  " + scoreAllTime[8].getName() + "\t" +scoreAllTime[8].getScore() +"\t" +scoreAllTime[8].getDateFormat() + "\n"
//                + "\t 10: " + scoreAllTime[9].getName() + "\t" +scoreAllTime[9].getScore() +"\t" +scoreAllTime[9].getDateFormat() + "\n"
//                + "This week: " + "\t 1:  " + scoreAllTime[0].getName() + "\t" +scoreAllTime[0].getScore() +"\t" +scoreAllTime[0].getDateFormat() +"\n"
//                + "\t 2:  " + scoreWeek[1].getName() + "\t" +scoreWeek[1].getScore() +"\t" +scoreWeek[1].getDateFormat() + "\n"
//                + "\t 3:  " + scoreWeek[2].getName() + "\t" +scoreWeek[2].getScore() +"\t" +scoreWeek[2].getDateFormat() + "\n"
//                + "\t 4:  " + scoreWeek[3].getName() + "\t" +scoreWeek[3].getScore() +"\t" +scoreWeek[3].getDateFormat() + "\n"
//                + "\t 5:  " + scoreWeek[4].getName() + "\t" +scoreWeek[4].getScore() +"\t" +scoreWeek[4].getDateFormat() + "\n"
//                + "\t 6:  " + scoreWeek[5].getName() + "\t" +scoreWeek[5].getScore() +"\t" +scoreWeek[5].getDateFormat() + "\n"
//                + "\t 7:  " + scoreWeek[6].getName() + "\t" +scoreWeek[6].getScore() +"\t" +scoreWeek[6].getDateFormat() + "\n"
//                + "\t 8:  " + scoreWeek[7].getName() + "\t" +scoreWeek[7].getScore() +"\t" +scoreWeek[7].getDateFormat() + "\n"
//                + "\t 9:  " + scoreWeek[8].getName() + "\t" +scoreWeek[8].getScore() +"\t" +scoreWeek[8].getDateFormat() + "\n"
//                + "\t 10: " + scoreWeek[9].getName() + "\t" +scoreWeek[9].getScore() +"\t" +scoreWeek[9].getDateFormat() + "\n"
//                + "This day: " + "\t 1:  " + scoreAllTime[0].getName() + "\t" +scoreAllTime[0].getScore() +"\t" +scoreAllTime[0].getDateFormat() +"\n"
//                + "\t 2:  " + scoreDay[1].getName() + "\t" +scoreDay[1].getScore() +"\t" +scoreDay[1].getDateFormat() + "\n"
//                + "\t 3:  " + scoreDay[2].getName() + "\t" +scoreDay[2].getScore() +"\t" +scoreDay[2].getDateFormat() + "\n"
//                + "\t 4:  " + scoreDay[3].getName() + "\t" +scoreDay[3].getScore() +"\t" +scoreDay[3].getDateFormat() + "\n"
//                + "\t 5:  " + scoreDay[4].getName() + "\t" +scoreDay[4].getScore() +"\t" +scoreDay[4].getDateFormat() + "\n"
//                + "\t 6:  " + scoreDay[5].getName() + "\t" +scoreDay[5].getScore() +"\t" +scoreDay[5].getDateFormat() + "\n"
//                + "\t 7:  " + scoreDay[6].getName() + "\t" +scoreDay[6].getScore() +"\t" +scoreDay[6].getDateFormat() + "\n"
//                + "\t 8:  " + scoreDay[7].getName() + "\t" +scoreDay[7].getScore() +"\t" +scoreDay[7].getDateFormat() + "\n"
//                + "\t 9:  " + scoreDay[8].getName() + "\t" +scoreDay[8].getScore() +"\t" +scoreDay[8].getDateFormat() + "\n"
//                + "\t 10: " + scoreDay[9].getName() + "\t" +scoreDay[9].getScore() +"\t" +scoreDay[9].getDateFormat());
    }

    /**
     * If the user selected a different level during the loading of the preview
     * of the previous level, this method creates a new thread which will load
     * the next level.
     */
    public void loadFinished() {
        if (nextLevel != null) {
            setScores();
            // user selected a different level during load.
            // when current load thread is finished (now),
            // load the other level, and reset nextLevel
            t = new LoadMazeThread(previewMaze, nextLevel);
            t.addLoadMazeListener(this);
            nextLevel = null;
            t.start();
        }
    }

    /**
     * This method gives all the playable levels in the folder mazes.
     */
    public void getLevels() {
        String extension;

        File folder = new File(Path.getMazesPath()+"\\");
        System.out.println(folder);
        if (!folder.isDirectory() || !folder.exists()) {
            System.out.println("Wrong folder.");
        }
        File[] listOfFiles = folder.listFiles();

        for (int i = 0; i < listOfFiles.length; i++) {
            int dotPos = listOfFiles[i].getName().lastIndexOf(".");
            extension = listOfFiles[i].getName().substring(dotPos);
            if (listOfFiles[i].isFile() && extension.equalsIgnoreCase(".ply")) {
                LevelList.addLevel(listOfFiles[i].getName().replace(extension, ""));

            }
        }
    }
    


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        LevelList = new biteme.ListBox();
        previewMaze = new biteme.Maze();
        MainMenuButton = new javax.swing.JButton();
        StartGame = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);

        LevelList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                LevelListMouseClicked(evt);
            }
        });
        LevelList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                LevelListValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(LevelList);

        previewMaze.setBackground(new java.awt.Color(0, 0, 0));
        previewMaze.setMaximumSize(new java.awt.Dimension(300, 200));
        previewMaze.setMinimumSize(new java.awt.Dimension(300, 200));
        previewMaze.setPreferredSize(new java.awt.Dimension(300, 200));

        javax.swing.GroupLayout previewMazeLayout = new javax.swing.GroupLayout(previewMaze);
        previewMaze.setLayout(previewMazeLayout);
        previewMazeLayout.setHorizontalGroup(
            previewMazeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
        previewMazeLayout.setVerticalGroup(
            previewMazeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 200, Short.MAX_VALUE)
        );

        MainMenuButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/main_menu.png"))); // NOI18N
        MainMenuButton.setActionCommand("MainMenu");
        MainMenuButton.setMaximumSize(new java.awt.Dimension(150, 20));
        MainMenuButton.setMinimumSize(new java.awt.Dimension(150, 20));
        MainMenuButton.setPreferredSize(new java.awt.Dimension(150, 20));
        MainMenuButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                MainMenuButton(evt);
            }
        });

        StartGame.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/start_game.png"))); // NOI18N
        StartGame.setActionCommand("StartGame");
        StartGame.setMaximumSize(new java.awt.Dimension(150, 20));
        StartGame.setMinimumSize(new java.awt.Dimension(150, 20));
        StartGame.setPreferredSize(new java.awt.Dimension(150, 20));
        StartGame.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                StartGame(evt);
            }
        });

        jTextArea1.setBackground(new java.awt.Color(236, 233, 216));
        jTextArea1.setColumns(45);
        jTextArea1.setEditable(false);
        jTextArea1.setRows(31);
        jTextArea1.setTabSize(12);
        jTextArea1.setAutoscrolls(false);
        jScrollPane2.setViewportView(jTextArea1);

        jLabel1.setText(Messages.LEVELSELECT_LIST_HEADER1);
        jLabel1.setAlignmentX(0.5F);
        jLabel1.setMaximumSize(new java.awt.Dimension(42, 14));
        jLabel1.setMinimumSize(new java.awt.Dimension(42, 14));
        jLabel1.setPreferredSize(new java.awt.Dimension(42, 14));
        
        jLabel2.setText(Messages.LEVELSELECT_LIST_HEADER2);
        jLabel2.setAlignmentX(0.5F);
        jLabel2.setMaximumSize(new java.awt.Dimension(42, 14));
        jLabel2.setMinimumSize(new java.awt.Dimension(42, 14));
        jLabel2.setPreferredSize(new java.awt.Dimension(42, 14));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(MainMenuButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(StartGame, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 296, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 296, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(217, 217, 217)
                                .addComponent(previewMaze, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGap(53, 53, 53))
                            .addGroup(layout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addContainerGap())))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 296, Short.MAX_VALUE)
                        .addGap(570, 570, 570))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(31, 31, 31)
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 495, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 274, Short.MAX_VALUE)
                        .addComponent(StartGame, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(MainMenuButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(32, 32, 32)
                        .addComponent(previewMaze, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 68, Short.MAX_VALUE)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 584, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        jLabel2.getAccessibleContext().setAccessibleName("levelSelectHeader");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void MainMenuButton(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_MainMenuButton
        MainMenu mainmenu = new MainMenu(null);
        mainmenu.setVisible(true);
        setVisible(false);
    }//GEN-LAST:event_MainMenuButton

    private void StartGame(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_StartGame
        if (selectedLevel != null) {
            GameGUI gameGUI = new GameGUI(this, selectedLevel);
            gameGUI.setVisible(true);
            this.setVisible(false);
        }
    }//GEN-LAST:event_StartGame

 
    private void LevelListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_LevelListValueChanged
        // TODO add your handling code here:
        selectedLevel = Path.getMazesPath() +
                        LevelList.getSelectedValue().toString() +
                        ".ply";
        try {

            if (!t.isAlive()) {
                t = new LoadMazeThread(previewMaze, selectedLevel);
                t.addLoadMazeListener(this);
                t.start();
                setScores();
            } else {
                nextLevel = selectedLevel;
            }
         } catch (Exception ex) {
            Popup.ok(ex.toString());
        }
    }//GEN-LAST:event_LevelListValueChanged

    private void LevelListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_LevelListMouseClicked
        // with double click start the selected game
        if(evt.getClickCount()==2){
           if (selectedLevel != null) {
                GameGUI gameGUI = new GameGUI(this, selectedLevel);
                gameGUI.setVisible(true);
                this.setVisible(false);
            }
        }

    }//GEN-LAST:event_LevelListMouseClicked
    /**
     * @param args the command line arguments
     */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private biteme.ListBox LevelList;
    private javax.swing.JButton MainMenuButton;
    private javax.swing.JButton StartGame;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea jTextArea1;
    private biteme.Maze previewMaze;
    // End of variables declaration//GEN-END:variables
}
