/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * LevelSelect.java
 *
 * Created on 9-dec-2009, 14:30:35
 */
package biteme;

import java.awt.Dimension;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.io.*;
import javax.swing.*;

/**
 * LevelSelect for the editor GUI
 * @author  J.H. van der Aa
 *          R.M.G. op het Veld
 */
public class LevelSelectEditor extends javax.swing.JFrame implements ILoadMazeThreadListener {

    private LoadMazeThread t;
    JFrame parent;
    private String selectedLevel = null;
    private String nextLevel = null;
    ImageIcon symbol = new ImageIcon();

    /** Creates new form LevelSelect
     * @param pParent the parent window of this instance
     */
    public LevelSelectEditor(JFrame pParent) {
        parent = pParent;

        initComponents();
        setIconImage(Toolkit.getDefaultToolkit().getImage(MainMenu.class.getResource("biteme_icon.png")));
        setTitle("BiteMe - Level Editor Load File");
        this.previewMaze.setLayout(new GridBagLayout());
        this.previewMaze.validate();

        Dimension minSize = new Dimension(980, 900);
        this.setMinimumSize(minSize);
        this.setPreferredSize(minSize);
        this.validate();
        getLevels();
        previewMaze.setTileSize(10);

        // standaard eerste level in de lijst tekenen
        selectedLevel = Path.getMazesPath() + LevelList.getLevelAtIndex(0);

        t = new LoadMazeThread(previewMaze, selectedLevel);
        t.addLoadMazeListener(this);
        t.start();
        LevelList.setSelectedIndex(0);
    }

    public void loadFinished() {
        if (nextLevel != null) {
            // user selected a different level during load.
            // when current load trhead is finished (now),
            // load the other level, and reset nextLevel
            t = new LoadMazeThread(previewMaze, nextLevel);
            t.addLoadMazeListener(this);
            nextLevel = null;
            t.start();
        }
    }

    /**
     * This method gives all the playable levels in the folder mazes.
     */
    public void getLevels() {
        String extension;

        File folder = new File(Path.getMazesPath());
        if (!folder.isDirectory() || !folder.exists()) {
            System.out.println("foute map");
        }
        File[] listOfFiles = folder.listFiles();

        for (int i = 0; i < listOfFiles.length; i++) {
            int dotPos = listOfFiles[i].getName().lastIndexOf(".");
            extension = listOfFiles[i].getName().substring(dotPos);
            if (listOfFiles[i].isFile() && (extension.equalsIgnoreCase(".ply") || extension.equalsIgnoreCase(".unp"))) {
                LevelList.addLevel(listOfFiles[i].getName());
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        LevelList = new biteme.ListBox();
        previewMaze = new biteme.Maze();
        BackButton = new javax.swing.JButton();
        Edit = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        LevelList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                LevelListMouseClicked(evt);
            }
        });
        LevelList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                LevelListValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(LevelList);

        previewMaze.setBackground(new java.awt.Color(0, 0, 0));
        previewMaze.setPreferredSize(new java.awt.Dimension(300, 200));

        javax.swing.GroupLayout previewMazeLayout = new javax.swing.GroupLayout(previewMaze);
        previewMaze.setLayout(previewMazeLayout);
        previewMazeLayout.setHorizontalGroup(
            previewMazeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
        previewMazeLayout.setVerticalGroup(
            previewMazeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 200, Short.MAX_VALUE)
        );

        BackButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/back.png"))); // NOI18N
        BackButton.setActionCommand("BackButton");
        BackButton.setMaximumSize(new java.awt.Dimension(150, 20));
        BackButton.setMinimumSize(new java.awt.Dimension(150, 20));
        BackButton.setPreferredSize(new java.awt.Dimension(150, 20));
        BackButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                BackButton(evt);
            }
        });

        Edit.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/edit.png"))); // NOI18N
        Edit.setActionCommand("Edit");
        Edit.setMaximumSize(new java.awt.Dimension(150, 20));
        Edit.setMinimumSize(new java.awt.Dimension(150, 20));
        Edit.setPreferredSize(new java.awt.Dimension(150, 20));
        Edit.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                Edit(evt);
            }
        });

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/renamemaze.png"))); // NOI18N
        jButton1.setMaximumSize(new java.awt.Dimension(150, 20));
        jButton1.setMinimumSize(new java.awt.Dimension(150, 20));
        jButton1.setPreferredSize(new java.awt.Dimension(150, 20));
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                Rename(evt);
            }
        });

        jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/deletemaze.png"))); // NOI18N
        jButton2.setMaximumSize(new java.awt.Dimension(150, 20));
        jButton2.setMinimumSize(new java.awt.Dimension(150, 20));
        jButton2.setPreferredSize(new java.awt.Dimension(150, 20));
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                Delete(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(BackButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(662, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 310, Short.MAX_VALUE)
                        .addComponent(previewMaze, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(112, 112, 112))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(Edit, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 495, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(Edit, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(BackButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addComponent(previewMaze, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void BackButton(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BackButton
        parent.setVisible(true);
        this.setVisible(false);
    }//GEN-LAST:event_BackButton

    private void Edit(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Edit
        if (selectedLevel != null) {
            EditorGUI editorGui = new EditorGUI(this, selectedLevel);
            editorGui.setVisible(true);
            this.setVisible(false);
        }
    }//GEN-LAST:event_Edit

    private void LevelListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_LevelListValueChanged
        // TODO add your handling code here:
        selectedLevel = Path.getMazesPath() +
                LevelList.getSelectedValue().toString();

        if (!t.isAlive()) {
            t = new LoadMazeThread(previewMaze, selectedLevel);
            t.addLoadMazeListener(this);
            t.start();
        } else {
            nextLevel = selectedLevel;
        }
    }//GEN-LAST:event_LevelListValueChanged

    private void LevelListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_LevelListMouseClicked

        if (evt.getClickCount() == 2) {
            if (selectedLevel != null) {
                EditorGUI editorGui = new EditorGUI(this, selectedLevel);
                editorGui.setVisible(true);
                this.setVisible(false);
            }
        }

    }//GEN-LAST:event_LevelListMouseClicked

    /**
     * Renames a file
     */
    private void Rename(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Rename

        if (selectedLevel != null) {
            String oldpath = selectedLevel;
            String ext;
            if (selectedLevel.endsWith(".ply")) {
                ext = ".ply";
            } else {
                ext = ".unp";
            }
            String mazename = MazeIO.getFileName(selectedLevel);
            String newname = Popup.savecancel("Rename the level " + mazename + " to: ","Enter Name");
            if (newname!=null){
            String newpath = Path.getMazesPath() + newname + ext;
            MazeIO.renameLevel(oldpath, newpath);

            LevelSelectEditor levelselect = new LevelSelectEditor(parent);
            levelselect.setVisible(true);
            this.setVisible(false);

            }
        }

    }//GEN-LAST:event_Rename

    private void Delete(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Delete
            String mazename = MazeIO.getFileName(selectedLevel);
            if (Popup.yesno("Are you sure you want to delete " +mazename)==0){
            MazeIO.deleteFile(selectedLevel);
            LevelSelectEditor levelselect = new LevelSelectEditor(parent);
            levelselect.setVisible(true);
            this.setVisible(false);
            }
    }//GEN-LAST:event_Delete

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BackButton;
    private javax.swing.JButton Edit;
    private biteme.ListBox LevelList;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JScrollPane jScrollPane1;
    private biteme.Maze previewMaze;
    // End of variables declaration//GEN-END:variables
}
