/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MainMenu.java
 *
 * Created on 25-nov-2009, 14:58:12
 */
package biteme;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.File;
import javax.swing.ImageIcon;
import javax.swing.JLabel;

/**
 * Main Menu GUI
 * @author s070693
 */
public class MainMenu extends javax.swing.JFrame {

    //private static MainMenu _instance = null;

    /** Private constructor to enforce Singleton pattern. Creates new form MainMenu */
    public MainMenu(String args[]) {
        initComponents();


        // remove default name
         File defnamefile = new File(Path.getMazesPath() + "default.nam");
         defnamefile.delete();

        // icon
        setIconImage(Toolkit.getDefaultToolkit().getImage(MainMenu.class.getResource("biteme_icon.png")));

        ImageIcon icon = new ImageIcon(
                Toolkit.getDefaultToolkit().getImage(MainMenu.class.getResource("logo.jpg")));
        JLabel label = new JLabel();
        label.setIcon(icon);
        logoPanel.add(label);

        Dimension minSize = new Dimension(980, 900);
        this.setMinimumSize(minSize);
        this.setPreferredSize(minSize);
        this.validate();

        boolean showMe = true;

        if (args != null && args.length > 0) {
            File f = new File(args[0]);
            if (f.exists()) {
                if (args[0].endsWith(".unp")) {
                    // open in editor
                    EditorGUI eg = new EditorGUI(this, args[0]);
                    eg.setVisible(true);
                    showMe = false;
                    
                } else if (args[0].endsWith(".ply")) {
                    // open in game
                    GameGUI gg = new GameGUI(this, args[0]);
                    gg.setVisible(true);
                    showMe = false;
                }
            }
        }
        
        if (showMe) {
            this.setVisible(true);
        }
    }

    /*public static MainMenu instance() {
        if (_instance == null) {
            _instance = new MainMenu(null);
        }
        return _instance;
    }*/

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        startGame = new javax.swing.JButton();
        LevelEditor = new javax.swing.JButton();
        Exit_button = new javax.swing.JButton();
        Credits_button = new javax.swing.JButton();
        logoPanel = new javax.swing.JPanel();
        Controls = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("BiteMe");
        setResizable(false);

        startGame.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/start.png"))); // NOI18N
        startGame.setMaximumSize(new java.awt.Dimension(150, 20));
        startGame.setMinimumSize(new java.awt.Dimension(150, 20));
        startGame.setPreferredSize(new java.awt.Dimension(150, 20));
        startGame.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                startGameMousePressed(evt);
            }
        });

        LevelEditor.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/level_editor.png"))); // NOI18N
        LevelEditor.setMaximumSize(new java.awt.Dimension(150, 20));
        LevelEditor.setMinimumSize(new java.awt.Dimension(150, 20));
        LevelEditor.setPreferredSize(new java.awt.Dimension(150, 20));
        LevelEditor.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                LevelEditorMousePressed(evt);
            }
        });

        Exit_button.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/exit.png"))); // NOI18N
        Exit_button.setActionCommand("Exit");
        Exit_button.setMaximumSize(new java.awt.Dimension(150, 20));
        Exit_button.setMinimumSize(new java.awt.Dimension(150, 20));
        Exit_button.setPreferredSize(new java.awt.Dimension(150, 20));
        Exit_button.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                Exit_buttonMousePressed(evt);
            }
        });

        Credits_button.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/credits.png"))); // NOI18N
        Credits_button.setActionCommand("Credits");
        Credits_button.setMaximumSize(new java.awt.Dimension(150, 20));
        Credits_button.setMinimumSize(new java.awt.Dimension(150, 20));
        Credits_button.setPreferredSize(new java.awt.Dimension(150, 20));
        Credits_button.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                Credits_buttonMousePressed(evt);
            }
        });

        logoPanel.setLayout(new java.awt.GridLayout(1, 1));

        Controls.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/help.png"))); // NOI18N
        Controls.setMaximumSize(new java.awt.Dimension(150, 20));
        Controls.setMinimumSize(new java.awt.Dimension(150, 20));
        Controls.setPreferredSize(new java.awt.Dimension(150, 20));
        Controls.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                ControlsMousePressed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(logoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 343, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 84, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(LevelEditor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(startGame, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(Exit_button, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(Credits_button, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(Controls, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(388, 388, 388))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(89, 89, 89)
                        .addComponent(startGame, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(LevelEditor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(5, 5, 5)
                        .addComponent(Credits_button, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Exit_button, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Controls, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(30, 30, 30)
                        .addComponent(logoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 261, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(293, Short.MAX_VALUE))
        );

        startGame.getAccessibleContext().setAccessibleName("startGame");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void startGameMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_startGameMousePressed
         LevelSelect levelselect = new LevelSelect(this);
        levelselect.setVisible(true);
        this.setVisible(false);
    }//GEN-LAST:event_startGameMousePressed

    private void LevelEditorMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_LevelEditorMousePressed
        EditorGUI editorGui = new EditorGUI(this, null);
        editorGui.setVisible(true);
        this.setVisible(false);
    }//GEN-LAST:event_LevelEditorMousePressed

    private void Credits_buttonMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Credits_buttonMousePressed
        Credits credits = new Credits(this);
        credits.setVisible(true);
        this.setVisible(false);
    }//GEN-LAST:event_Credits_buttonMousePressed

    private void Exit_buttonMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Exit_buttonMousePressed
        System.exit(0);
    }//GEN-LAST:event_Exit_buttonMousePressed

    private void ControlsMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ControlsMousePressed
        // TODO add your handling code here:
        Help help = new Help(this);
        help.setVisible(true);
        this.setVisible(false);
    }//GEN-LAST:event_ControlsMousePressed

    /**
     * @param args the command line arguments
     */
    public static void main(final String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                try {
                    MainMenu m = new MainMenu(args);
                } catch (Exception ex) {
                    Popup.ok(ex.toString());
                }
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Controls;
    private javax.swing.JButton Credits_button;
    private javax.swing.JButton Exit_button;
    private javax.swing.JButton LevelEditor;
    private javax.swing.JPanel logoPanel;
    private javax.swing.JButton startGame;
    // End of variables declaration//GEN-END:variables
}
