/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package biteme;

/**
 * Class exposing static Strings carrying information about the locations of the maze files and sound files.
 * @author N.F.W. Thissen
 */
public class Path {

    /**
     * Reads the 'My Documents' folder location from the registry.
     * @return The 'My Documents' folder location.
     */
    private static String getMyDocumentsPath() {
        int handle = RegUtil.RegOpenKey(RegUtil.HKEY_CURRENT_USER,
                "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders",
                RegUtil.KEY_READ)[RegUtil.NATIVE_HANDLE];
        byte[] val = RegUtil.RegQueryValueEx(handle, "Personal");
        String path = new String(val).trim();
        RegUtil.RegCloseKey(handle);
        return path;
    }

    /**
     * Gets the directory in which the maze files should be stored.
     * @return The directory in which the maze files should be stored.
     */
    public static String getMazesPath() {
        String path = getMyDocumentsPath();
        path += "\\SHARP\\BiteMe\\mazes\\";
        return path;
    }

    /**
     * Gets the directory in which the sound files should be stored.
     * @return The directory in which the sound files should be stored.
     */
    public static String getSoundsPath() {
        String path = getMyDocumentsPath();
        path += "\\SHARP\\BiteMe\\sounds\\";
        return path;
    }
}
